<?php
namespace Folha\Entities;

use HCM\Util\DateUtil;
use Importacao\Logic\Integracao\ProjetoImportacao;

class MigGozoferias extends Base\MigGozoferias
{

    const DEFAULT_IDADIANT13 = 'N';

    /**
     * @param $nrgozoferias
     * @return \Folha\Entities\MigGozoferias
     */
    public function setNrgozoferias ($nrgozoferias) {
        $nrgozoferias = \Importacao\Logic\Validacoes::verificaChaveDuplicada('FPA_GOZOFERIAS', 'NRGOZOFERIAS', ProjetoImportacao::getNrorg(), $nrgozoferias);
        $this->nrgozoferias = $nrgozoferias;
    }

    /**
     * @param $nrferias
     * @return \Folha\Entities\MigGozoferias
     */
    public function setNrferias ($nrferias) {
        $nrferias = \Importacao\Logic\Validacoes::verificaChaveMae('FPA_FERIAS', 'NRFERIAS', ProjetoImportacao::getNrorg(), $nrferias);
        $this->nrferias = $nrferias;
    }

    /**
     * @param $idadiant13salar
     * @return \Folha\Entities\MigGozoferias
     */
    public function setIdadiant13salar ($idadiant13salar) {
        if (empty($idadiant13salar)) {
            $idadiant13salar = self::DEFAULT_IDADIANT13;
        }
        $this->idadiant13salar = $idadiant13salar;
    }

    /**
     * @param $dtinigozoferias
     * @throws \Exception
     * @return \Folha\Entities\MigGozoferias
     */
    public function setDtinigozoferias ($dtinigozoferias) {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtinigozoferias)) {
            if (!empty($dtinigozoferias)) {
                throw new \Exception("Início Gozo: Data '$dtinigozoferias' com formato inválido ou em branco.");
            } else {
                throw new \Exception(null);
            }
        }

        if (!($dtinigozoferias instanceof \DateTime)) {
            $dtinigozoferias = DateUtil::getDataDeString($dtinigozoferias);
        }

        $this->dtinigozoferias = $dtinigozoferias;
    }

    /**
     * @param $dtfimgozoferias
     * @throws \Exception
     * @return \Folha\Entities\MigGozoferias
     */
    public function setDtfimgozoferias ($dtfimgozoferias) {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtfimgozoferias)) {
            if (!empty($dtfimgozoferias)) {
                throw new \Exception("Fim Gozo: Data '$dtfimgozoferias' com formato inválido ou em branco.");
            } else {
                throw new \Exception(null);
            }
        }

        if (!($dtfimgozoferias instanceof \DateTime)) {
            $dtfimgozoferias = DateUtil::getDataDeString($dtfimgozoferias);
        }

        $this->dtfimgozoferias = $dtfimgozoferias;
    }

    /**
     * @param $dtretornoferias
     * @throws \Exception
     * @return \Folha\Entities\MigGozoferias
     */
    public function setDtretornoferias ($dtretornoferias) {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtretornoferias)) {
            throw new \Exception("Campo Obrigatório - Dt. Retorno Férias: Data '$dtretornoferias' com formato inválido ou em branco.");
        }

        if (!($dtretornoferias instanceof \DateTime)) {
            $dtretornoferias = DateUtil::getDataDeString($dtretornoferias);
        }

        $this->dtretornoferias = $dtretornoferias;
    }

    /**
     * @param $dtultatu
     * @throws \Exception
     * @return \Folha\Entities\MigGozoferias
     */
    public function setDtultatu ($dtultatu) {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtultatu)) {
            throw new \Exception("Data '$dtultatu' com formato inválido ou em branco.");
        }

        if (!($dtultatu instanceof \DateTime)) {
            $dtultatu = DateUtil::getDataDeString($dtultatu);
        }

        $this->dtultatu = $dtultatu;
    }

    /**
     * @param $dtinclusao
     * @throws \Exception
     * @return \Folha\Entities\MigGozoferias
     */
    public function setDtinclusao ($dtinclusao) {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtinclusao)) {
            throw new \Exception("Data '$dtinclusao' com formato inválido ou em branco.");
        }

        if (!($dtinclusao instanceof \DateTime)) {
            $dtinclusao = DateUtil::getDataDeString($dtinclusao);
        }

        $this->dtinclusao = $dtinclusao;
    }

}