<?php
namespace Geral\Repositories;

class Opergrupop extends \Doctrine\ORM\EntityRepository
{
    public static function checaOperacaoProposta($cdperador){
        $sql = "SELECT OG.CDOPERADOR, O.NMOPERADOR, OG.CDGRUPOPER
                FROM OPERGRUPOP OG, OPERADOR O, GRUPOPER G, AUTGRUPOP A
               WHERE OG.CDGRUPOPER = G.CDGRUPOPER
                 AND OG.CDGRUPOPER = A.CDGRUPOPER
                 AND OG.CDOPERADOR = O.CDOPERADOR
                 AND A.IDAUTGRUPOP = 'PROP'
                 AND OG.CDGRUPOPER = '63'
                 AND OG.CDOPERADOR = :CDOPERADOR";
      
        $param = array(":CDOPERADOR" => $cdperador);
        try {
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $param);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function localizacaoHabilitadaOperador($filial, $almoxarifado, $local, $operador){
        $sql = <<<SQL
                        SELECT CDALMOXARIFE, CDLOCALESTOQ
                          FROM GROPERLESTOQ G, OPERGRUPOP O
                         WHERE G.CDFILIAL = :P_CDFILIAL
                           AND O.CDOPERADOR = :P_CDOPERADOR
                           AND G.CDALMOXARIFE = :P_CDALMOXARIFE
                           AND G.CDLOCALESTOQ = :P_CDLOCALESTQ
                           AND G.CDGRUPOPER = O.CDGRUPOPER
                         UNION
                        SELECT CDALMOXARIFE, CDLOCALESTOQ
                          FROM OPERLESTOQ G
                         WHERE G.CDFILIAL = :P_CDFILIAL
                           AND G.CDALMOXARIFE = :P_CDALMOXARIFE
                           AND G.CDLOCALESTOQ = :P_CDLOCALESTQ
                           AND G.CDOPERADOR = :P_CDOPERADOR
SQL;

        $params = array(
            "P_CDFILIAL" => $filial,
            "P_CDALMOXARIFE" => $almoxarifado,
            "P_CDLOCALESTQ" => $local,
            "P_CDOPERADOR" => $operador,
        );

        try{
            return self::getEntityManager()->getConnection()->fetchArray($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }

    public function almoxarifadoHabilitadaOperador($filial, $almoxarifado, $operador){
        $sql = <<<SQL
                        SELECT CDALMOXARIFE
                          FROM GROPERALMOX G, OPERGRUPOP O
                         WHERE (G.CDFILIAL = :P_CDFILIAL)
                           AND (O.CDOPERADOR = :P_CDOPERADOR)
                           AND (G.CDGRUPOPER = O.CDGRUPOPER)
                           AND (G.CDALMOXARIFE = :P_CDALMOXARIFE)
                         UNION
                        SELECT CDALMOXARIFE
                          FROM OPERALMOX
                         WHERE CDFILIAL = :P_CDFILIAL
                           AND CDOPERADOR = :P_CDOPERADOR
                           AND CDALMOXARIFE = :P_CDALMOXARIFE
SQL;

        $params = array(
            "P_CDFILIAL" => $filial,
            "P_CDALMOXARIFE" => $almoxarifado,
            "P_CDOPERADOR" => $operador,
        );

        try{
            return self::getEntityManager()->getConnection()->fetchArray($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }
}