<?php
namespace Geral\Repositories;

class Parasupri extends \Doctrine\ORM\EntityRepository
{
    /**
     * Verifica se o fornecedor é qualificado
     *
     * @param String $cdforneced   Fornecedor
     * @param String $idultidtvalq Data última validade
     * @param String $dtcoleprec   Data Coleta
     *
     * @return array
     * @throws \Exception
     */
    public function verificaFornecedorQualificado($cdforneced,
        $idultidtvalq, $dtcoleprec)
    {
        try {
            $sql
                = <<<SQL
        SELECT FORNECEDOR.CDFORNECED
        FROM FORNECEDOR,
          QUALIFICACAO
        WHERE FORNECEDOR.CDFORNECED    = :P_CDFORNECED
        AND (FORNECEDOR.CDQUALIF      IS NOT NULL
        AND FORNECEDOR.CDQUALIF        = QUALIFICACAO.CDQUALIF
        AND ((QUALIFICACAO.IDPERCOTCMP = '1')
        OR (QUALIFICACAO.IDPERCOTCMP   = '2'
        AND FORNECEDOR.IDFORNAUTO      = 'S'))
        AND ( (:P_IDULTIDTVALQ         = 'D'
        AND :P_DTCOLEPREC             <= FORNECEDOR.DTVALQUALIF)
        OR (:P_IDULTIDTVALQ            = 'M'
        AND :P_DTCOLEPREC             <= LAST_DAY(FORNECEDOR.DTVALQUALIF)) ) )
        UNION
        SELECT FORNECEDOR.CDFORNECED
        FROM FORNECEDOR
        WHERE FORNECEDOR.CDFORNECED = :P_CDFORNECED
        AND FORNECEDOR.CDQUALIF    IS NULL
SQL;
            $params = array(
                'P_CDFORNECED' => $cdforneced,
                'P_IDULTIDTVALQ' => $idultidtvalq,
                'P_DTCOLEPREC' => $dtcoleprec
            );

            return $this->getEntityManager()->getConnection()->fetchAll(
                $sql, $params
            );

        } catch (\Exception $e) {
            throw $e;
        }
    }

}